/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.extension.rumblepad;

import static org.fortiss.af3.expression.utils.ExpressionModelElementFactory.funcCall;
import static org.fortiss.af3.expression.utils.ExpressionModelElementFactory.intConst;

import org.fortiss.af3.component.model.OutputPort;
import org.fortiss.af3.expression.model.terms.FunctionCall;
import org.fortiss.af3.expression.model.terms.IExpressionTerm;
import org.fortiss.af3.platform.language.executable.IWritableExecutable;
import org.fortiss.af3.platform.raspberry.model.rumblepad.SimpleRumbleFeature;

/** Executable for {@link SimpleRumbleFeature}. */
public class SimpleRumbleFeatureGeneratorExtension extends RumblepadGeneratorExtensionBase<SimpleRumbleFeature>
		implements IWritableExecutable {
	/** Constructor. */
	public SimpleRumbleFeatureGeneratorExtension(SimpleRumbleFeature modelElement) {
		super(modelElement);
	}

	/** {@inheritDoc} */
	@Override
	public IExpressionTerm getValueWriteAccessor(OutputPort logicalSignal, IExpressionTerm value) {
		FunctionCall fc = funcCall("rumblepad_set_rumble", value, value);
		fc.getArguments().add(intConst(500));
		fc.getArguments().add(intConst(0));
		return fc;
	}
}
